<'
import evc_util/e/evc_util_top;
struct example_packet_s like any_sequence_item
{
     a : uint (bits: 3);
};

sequence example_sequence using
item=example_packet_s,
created_kind=example_seq_kind_t,
created_driver=example_driver_u;

extend MAIN example_sequence
{
     //If you uncomment following line, no messages will be printed after test command
     --body() @driver.clock is only { };
};

extend example_seq_kind_t : [TEST1, TEST2];
extend TEST1 example_sequence
{
     body() @driver.clock is first
     {
          outf ("TEST1 ");
          do packet;
     };
};

extend TEST2 example_sequence
{
     body() @driver.clock is first
     {
          outf ("TEST2 ");
          do packet;
     };
};

extend RANDOM example_sequence
{
     body() @driver.clock is first
     {
          outf ("RANDOM ");
     };
};

extend SIMPLE example_sequence
{
     body() @driver.clock is first
     {
          outf ("SIMPLE ");
     };
};

unit example_bfm_u
{
     driver : example_driver_u;
     event clk_r is cycle @sys.any;
     drive_packet(p : example_packet_s) @clk_r is
     {
          outf ("[%d] DRIVER :: packet.a = 0x%x\n", sys.time, p.a);
          wait [10];
     };

     on clk_r { emit driver.clock; };
};

unit example_agent_u
{
     env : example_env_u;
     bfm : example_bfm_u is instance;
     drv : example_driver_u is instance;

     keep bfm.driver == drv;
};

extend example_bfm_u
{
     execute_items() @clk_r is
     {
          var seq_item: example_packet_s;
          while TRUE
          {
               seq_item = driver.get_next_item();
               drive_packet(seq_item);
               emit driver.item_done;
          };
     };

     run() is also { start execute_items(); };
};

extend example_sequence
{
     !packet: example_packet_s;
};

unit example_env_u like any_env
{
     agent : example_agent_u is instance;

     keep agent.env == me;
};

extend sys
{
     a : example_env_u is instance;
};
'>
