<'
import evc_util/e/evc_util_top;
struct example_packet_s like any_sequence_item
{
  a : uint (bits: 3);
};

sequence example_sequence using
item=example_packet_s,
created_kind=example_seq_kind_t,
created_driver=example_driver_u;

extend MAIN example_sequence
{
  //demonstrate virtual sequence
  body() @driver.clock is only { };
};

extend example_seq_kind_t : [TEST1, TEST2];
extend TEST1 example_sequence
{
  body() @driver.clock is first
  {
    outf ("dbg TEST1 \n");
    do packet;
  };
};

extend TEST2 example_sequence
{
  body() @driver.clock is first
  {
    outf ("dbg TEST2 \n");
    do packet;
  };
};

extend RANDOM example_sequence
{
  body() @driver.clock is first
  {
    outf ("dbg RANDOM \n");
  };
};

extend SIMPLE example_sequence
{
  body() @driver.clock is first
  {
    outf ("dbg SIMPLE \n");
  };
};

unit example_bfm_u
{
  driver : example_driver_u;
  event clk_r is cycle @sys.any;
  drive_packet(p : example_packet_s) @clk_r is
  {
    outf ("dbg [%d] DRIVER :: packet.a = 0x%x\n", sys.time, p.a);
    wait [10];
  };
  
  on clk_r { emit driver.clock; };
};

unit example_agent_u
{
  env : example_env_u;
  bfm : example_bfm_u is instance;
  drv : example_driver_u is instance;
  
  keep bfm.driver == drv;
};

extend example_bfm_u
{
  execute_items() @clk_r is
  {
    var seq_item: example_packet_s;
    while(TRUE) {
      seq_item = driver.get_next_item();
      drive_packet(seq_item);
      emit driver.item_done;
    };
  };
  run() is also { start execute_items(); };
};  
extend example_sequence
{
  !packet: example_packet_s;
};

//virtual sequence
sequence virt_seq;
extend virt_seq_driver {
  drv_a : example_driver_u;
};

unit example_env_u like any_env
{
  agent : example_agent_u is instance;
  keep agent.env == me;

  //virtual sequence
  driver : virt_seq_driver is instance;
  keep driver.drv_a == agent.drv;
};
//virtual sequence clock
extend virt_seq_driver {
  event clock is only @sys.any;
};
extend MAIN virt_seq {
  !a_seq_1 : TEST1 example_sequence;
  !a_seq_2 : TEST2 example_sequence;
  !a_seq   :       example_sequence;

  body() @driver.clock is only {
    do a_seq_1 keeping {.driver == driver.drv_a};
    do a_seq_2 keeping {.driver == driver.drv_a};
    for i from 0 to 47 {
      do a_seq keeping {.driver == driver.drv_a};
    };
  };
};

extend sys
{
  a : example_env_u is instance;

  setup() is also {
  //set_config(run, tick_max, MAX_INT, exit_on, all);
    set_config(run, tick_max, 500000, exit_on, all);
  };
};
'>
